<?php

Class ArticleAction extends CommonAction {

	
        public function saveTag($vo,$list,$module) {
            if (!empty($vo) && !empty($list)) {
                $Tag = M("Tag");
                $Tagged = M("Tagged");
                $tags = explode(' ',$vo['tags']);
                foreach($tags as $key=>$val) {
                    $val = trim($val);
                    if (!empty($val)) {
                       // 记录已经存在的标签
                       $map["module"] = "Article";
                       $map["name"] = $val;
                       $tagg = $Tag->where($map)->find();
                        if ($tagg) {
							$tagId = $tagg['id'];
                            $Tag->setInc('count','id='.$tagg["id"]);
                        }else {
                            $t = array();
                            $t["name"] = $val;
                            $t["count"] = 1;
                            $t["module"] = $module;
                            $result = $Tag->add($t);
                            $tagId = $result;
                       }
                    }
					//记录tag信息
					$t = array();
					$t["module"] = $module;
					$t["recordId"] = $list;
					$t["tagTime"] = time();
					$t["tagId"] = $tagId;
					$Tagged->add($t);
                }
            }
        }
       // 保存日志的标签和附件
	public function _trigger($vo,$list) {
		if(ACTION_NAME=='insert') {
            $dao = M("Attach");
			$attach['verify'] = 0;
			$attach['recordId'] = $list;
            $dao->where("verify='".$_SESSION["attach_verify"]."'")->save($attach);
		}
		$this->saveTag($vo,$list,"Article");
	}


   public function insert() {
		$Article = D("Article");
		if ($vo = $Article->create()) {
			$list = $Article->add();
			if ($list) {
				//数据保存触发器
				if (method_exists($this,'_trigger')) {
					$this->_trigger($vo,$list);
				}
				$this->success("操作成功");
			}else {
				$this->error("操作失败");
			}
		}else {
			$this->error($Article->getError());
		}
	}
        
	// 查看分类文章
        public function category() {
            $pid = $_GET["pid"];
        	$id = $_REQUEST["id"];
            if (!empty($id)) {
                $CateList = M("Category");
                if ($CateList) {
                    $categoryName = $CateList->where('id='.$id and 'id='.$pid)->getField("title");
                    $this->assign('categoryName', $categoryName);
                    $dao = D('ArticleView');
                    //导入分页类
                    import("@.ORG.Page");
                    //取得满足条件的记录数
                    $count = $dao->where('status=1')->where('categoryId='.$id)->count();
                    $p = new Page($count, 5);
                    //分页查询数据
                    $voList = $dao->where('status=1')->where('categoryId='.$id)->limit($p->firstRow.','.$p->listRows)->select();
                    //分页显示
                    $page = $p->show();
                    //模板赋值显示
                    $this->assign('list', $voList);
                    $this->assign("count", $count);
                    $this->assign("page", $page);
                }else {
                   $this->redirect('index');
                   return ;
                }
            }else {
                $this->redirect('index');
            }
            
            $this->display();
            return ;
        }

        public function show() {
            $this->getComment();
            $this->getAttach();
            $id = $_REQUEST["id"];
            if (!empty($id)) {
               $Article = D("ArticleView");
               $result = $Article->where('Article.id='.$id)->find();  // 这里为什么用select()就读不出来
               if ($result) {
                   $this->assign('vo', $result);
               }else {
                   $this->redirect('index');
                   return ;
               }
            }else {
                $this->redirect('index');
            }
            $this->display();
            return ;
        }

        public function _after_show() {
            $Article = D("Article");
            $article = $this->get('vo');
            // 阅读计数
            $id	= $article["id"];
            if(!isset($_SESSION['article_read_count_'.$id])) {
		$Article->setInc('readCount',"id=".$id);
		$_SESSION['article_read_count_'.$id] = true;
            }
        }

        public function _before_add() {
                $verify = build_verify(8);
                $_SESSION['attach_verify'] = $verify;
                $this->assign('verify',$verify);
        }
        public function add() {
        				
		    $Cate = M("Category");
		    $cateList = $Cate->findAll();
		    $this->assign("category", $cateList);
            $this->display();
        }
	public function index() {
	       $Cate = M("Category");
		//$cateList = $Cate->findAll();
		//$cateList = list_to_tree();

		   $cateList=$Cate->field("id,title,pid,path,concat(path,'-',id) as bpath")->order('bpath')->select();
	          foreach($cateList as $key=>$value){
				$cateList[$key]['count']=count(explode('-',$value['bpath']));
			}
		    $this->assign("category", $cateList);
	    
        
                if (ACTION_NAME != "add") {
                    //切换到高级模型
                    $Article = M("Article", "AdvModel");
                    $Comment = M("Comment", "AdvModel");
                    // 需要将msubstr()从扩展库extend.php中拷贝到common.php中
                    $new = $Article->where('status=1')->order("cTime desc")->top10();
                    $comment = $Comment->where('status=1')->order("id desc")->top8();
                    $this->assign("lastArticles", $new);
                    $this->assign("lastComments", $comment);
                    // 标签列表
                    $List = M("Tag");
                    $list  = $List->where("module='Article'")->field('id,name,count')->order('count desc')->limit('0,25')->findAll();
                    $this->assign('tags',$list);

                    $list = array();
                    // 获取归档文章
                    if(!isset($_SESSION["ArticleArchiveList2"])) {
                        $Article = M("Article");
                        $new = $Article->max("cTime");
                        $old = strtotime("-1 year");
                        $time = $new;
                        while($time>=$old) {
                            $list[] = array('year'=>date('Y',$time),'month'=>date('m',$time),'show'=>$time);
                            $time = strtotime('-1 month',$time);
			}
                        $_SESSION['ArticleArchiveList2'] = $list;
                    }else {
                        $list = $_SESSION['ArticleArchiveList2'];
                    }
                    $this->assign('monthList',$list);
                }
		
            $Article = D("ArticleView");
            $count = $Article->count();
            $mode = "normal";
            if (isset($_REQUEST["mode"])) {
                $mode = $_REQUEST["mode"];
            }
            if ($mode == "list") {
                $listRows = 23;
                //$fields	= 'id,title,categoryId,category,cTime,readCount,commentCount';
            }else {
                $listRows = 3;
                //$fields	= 'id,title,categoryId,cTime,readCount,commentCount,content,tags';
            }
            import("@.ORG.Page");
            $p = new Page($count, $listRows);
            $p->setConfig("header", "篇文章");
            $this->assign("mode", $mode);
            $list =  $Article->order("cTime desc")->limit($p->firstRow.','.$p->listRows)->select();
            $page = $p->show();
            $this->assign("list", $list);
            $this->assign("count", $count);
            $this->assign("page", $page);

            //统计数据
            $Article = M("Article");
            $stat = array();
            $stat["beginTime"] = $Article->min('cTime');
            $stat["articleCount"] = $Article->where("status=1")->count();
            $stat["readCount"] = $Article->where("status=1")->sum("readCount");
            $stat["commentCount"] = $Article->where("status=1")->sum("commentCount");
            $this->assign($stat);

            $this->display();
            
            
	}

        // 获取归档文章
        public function archive() {
            if (checkdate($_REQUEST["month"],'01',$_REQUEST["year"])) {
                $Article = D('ArticleView');
                $begin_time = strtotime($_REQUEST["year"].$_REQUEST["month"]."01");
                $end_time = strtotime("+1 month", $begin_time);
                //$this->assign('title',toDate($begin_time,'Y年m月').' 归档文章');
				import("@.ORG.Page");
                $map = "Article.cTime > $begin_time and Article.cTime < $end_time and Article.status=1";
                $count = $Article->where($map)->count();
				$listRows = 5;
				$p = new Page($count, $listRows);
                $voList  = $Article->where($map)->order('Article.cTime desc')->limit($p->firstRow.','.$p->listRows)->findAll();
                //模板赋值显示
				$page = $p->show();
				$this->assign("page", $page);
				$this->assign('date',$begin_time);
                $this->assign('list',$voList);
				$this->assign("count",$count);
            }
            $this->display();
        }

        public function tag() {
            $Tag = M("Tag");
            if(!empty($_GET['name'])) {
                $name = trim($_REQUEST['name']);
                $list = $Tag->where("module='Article' and name='$name'")->field('id,count')->find();
				$tagId = $list['id'];
				$count = $list['count'];
				import("@.ORG.Page");
				$listRows = 5;
				$fields	= 'a.id,a.userId,a.categoryId,a.cTime,a.readCount,a.commentCount,a.title,c.title as category';
				$p = new Page($count,$listRows);
				$p->setConfig('header' ,'篇文章 ');
				$dao = D("Article");
				$list = $dao->query("select ".$fields." from ".C('DB_PREFIX').'article as a,'.C('DB_PREFIX').'tagged as b, '.C('DB_PREFIX').'category as c where b.tagId  in ('.$tagId.') and a.categoryId= c.id and a.status=1  and a.id=b.recordId order by a.id desc limit '.$p->firstRow.','.$p->listRows);
				if($list) {
                    $page = $p->show();
                    $this->assign("page", $page);
                    $this->assign('list',$list);
                }
                $this->assign('tag',$name);
                $this->assign("count",$count);
            }else {
                $list = $Tag->where("module='Article'")->findAll();
                //dump($list);
                $this->assign('tags',$list);
            }
            $this->display();
        }

        public function edit() {
            $Article = M("Article");
            $id = $_REQUEST['id'];
            $article = $Article->where('id='.$id)->find();
            //dump($article);
            if($article) {
                $this->getAttach();
                $this->assign('vo',$article);
                $this->display();
            }else{
                $this->redirect('Article/index');
            }
	}
        public function update() {
            $model = D("Article");
            $vo = $model->create('','edit');
            if(!$vo) {
                $this->error($model->getError());
            }
            $id	= is_array($vo)?$vo[$model->getPk()]:$vo->{$model->getPk()};
            $result  = $model->save($vo);
            if($result) {

                //数据保存触发器
                if(method_exists($this,'_trigger')) {
                    $this->_trigger($vo, $result);
                }

                if(!empty($_FILES)) {//如果有文件上传
                    //执行默认上传操作
                    //保存附件信息到数据库
                   $this->_upload(MODULE_NAME,$result);
                }

                //成功提示
                $this->success("操作成功！");
            }else {
                //错误提示
                $this->error($model->getError());
            }
        }
        	  // 删除数据 
    public function delete() { 
        if(!empty($_POST['id'])) { 
            $Article    =    M("Article"); 
            $result    =    $Article->delete($_POST['id']); 
            if(false !== $result) { 
                $this->ajaxReturn($_POST['id'],'删除成功！',1); 
            }else{ 
                $this->error('删除出错！'); 
            } 
        }else{ 
            $this->error('删除项不存在！'); 
        } 
    } 

}
?>